# wxValidator Class Reference
[Validators]

`#include <wx/validate.h>`

Inheritance diagram for wxValidator:
[legend]

## Detailed Description

wxValidator is the base class for a family of validator classes that mediate between a class of control, and application data.

A validator has three major roles:

1. To transfer data from a C++ variable or own storage to and from a control.
2. To validate data in a control, and show an appropriate error message.
3. To filter events (such as keystrokes), thereby changing the behaviour of the associated control.

Validators can be plugged into controls dynamically.

To specify a default, "null" validator, use wxDefaultValidator.

For more information, please see wxValidator Overview.

wxPython Note: If you wish to create a validator class in wxPython you should derive the class from `wxPyValidator` in order to get Python-aware capabilities for the various virtual methods.

##

Library: wxCore

Category: Validators

Predefined objects/pointers: wxDefaultValidator

See also:
  wxValidator Overview, wxTextValidator, wxGenericValidator, wxIntegerValidator, wxFloatingPointValidator

## Public Member Functions
| wxValidator ()
| Constructor.
virtual | ~wxValidator ()
| Destructor.
virtual wxObject * | Clone () const
| All validator classes must implement the Clone() function, which returns an identical copy of itself.
wxWindow * | GetWindow () const
| Returns the window associated with the validator.
void | SetWindow (wxWindow *window)
| Associates a window with the validator.
virtual bool | TransferFromWindow ()
| This overridable function is called when the value in the window must be transferred to the validator.
virtual bool | TransferToWindow ()
| This overridable function is called when the value associated with the validator must be transferred to the window.
virtual bool | Validate (wxWindow *parent)
| This overridable function is called when the value in the associated window must be validated.
## Static Public Member Functions
static void | SuppressBellOnError (bool suppress=true)
| This functions switches on or turns off the error sound produced by the validators if an invalid key is pressed.

List of all members.

## Constructor & Destructor Documentation

wxValidator::wxValidator | ( |  | ) |

Constructor.

virtual wxValidator::~wxValidator | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual wxObject* wxValidator::Clone | ( |  | ) | const`[virtual]`

All validator classes must implement the Clone() function, which returns an identical copy of itself.

This is because validators are passed to control constructors as references which must be copied. Unlike objects such as pens and brushes, it does not make sense to have a reference counting scheme to do this cloning because all validators should have separate data.

Returns:
  This base function returns NULL.

Reimplemented in wxGenericValidator, and wxTextValidator.

wxWindow* wxValidator::GetWindow | ( |  | ) | const

Returns the window associated with the validator.

void wxValidator::SetWindow | ( | wxWindow * | window | ) |

Associates a window with the validator.

This function is automatically called by wxWidgets when creating a wxWindow-derived class instance which takes a wxValidator reference.

E.g.

            new wxTextCtrl(this, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0,
                           wxTextValidator(wxFILTER_ALPHA, &g_data.m_string));

will automatically link the wxTextValidator instance with the wxTextCtrl instance.

static void wxValidator::SuppressBellOnError | ( | bool | suppress = `true` | ) | `[static]`

This functions switches on or turns off the error sound produced by the validators if an invalid key is pressed.

Since:
  2.9.1

Parameters:

  | suppress | If true, error sound is not played when a validator detects an error. If false, error sound is enabled.

virtual bool wxValidator::TransferFromWindow | ( |  | ) | `[virtual]`

This overridable function is called when the value in the window must be transferred to the validator.

Returns:
  false if there is a problem.

Reimplemented in wxGenericValidator, wxNumValidator< T >, wxTextValidator, and wxNumValidator< T >.

virtual bool wxValidator::TransferToWindow | ( |  | ) | `[virtual]`

This overridable function is called when the value associated with the validator must be transferred to the window.

Returns:
  false if there is a problem.

Reimplemented in wxGenericValidator, wxNumValidator< T >, wxTextValidator, and wxNumValidator< T >.

virtual bool wxValidator::Validate | ( | wxWindow * | parent | ) | `[virtual]`

This overridable function is called when the value in the associated window must be validated.

Parameters:

  | parent | The parent of the window associated with the validator.

Returns:
  false if the value in the window is not valid; you may pop up an error dialog.

Reimplemented in wxTextValidator.

|  | [ top ]